/*************************************************************************
GRANVIL software:  January, 2010

Contributors:
    * Andrew P Morris amorris@well.ox.ac.uk
    * Reedik Magi reedik@well.ox.ac.uk

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*************************************************************************/

#ifndef __MARKER_H__
#define __MARKER_H__

#include <string>
#include <vector>

class marker
{
public:
	marker(std::string name, char effectAllele, char nonEffectAllele, std::vector <double> genotype);
	~marker(void);
	double getGenotype(unsigned int i);
	std::string getName(){return _name;}
	void setPosition(int position){_position = position;} 
	void setChromosome(int chr){_chromosome = chr;}
	int getPosition(){return _position;} 
	int getChromosome(){return _chromosome;}
	void setMaf(double maf){_maf = maf;} 
	double getMaf(){return _maf;} 

	unsigned long getGenotypeCount(){return _genotype.size();}

private:
	std::string _name;
	int _position;
	int _chromosome;
	std::vector <double> _genotype;
	char _ea;
	char _nea;
	double _maf;
};
#endif

