/*************************************************************************
GRANVIL software:  January, 2010

Contributors:
    * Andrew P Morris amorris@well.ox.ac.uk
    * Reedik Magi reedik@well.ox.ac.uk

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*************************************************************************/


#pragma once

#include "structures.h"

class lr
{

private:
	matrixD * V;			// Least squares and var/covar matrix
	double RYSQ;			// Multiple correlation coefficient
	double SDV;				// Standard deviation of errors
	double FReg;			// Fisher F statistic for regression
	arrayD * Ycalc;			// Calculated values of Y
	arrayD * DY;			// Residual values of Y

	bool isC, isSEC, isV, isYcalc, isDY;

		
public:
	arrayD * Cstat;				// Coefficients	
	arrayD * SECstat;			// Std Error of coefficients	
	bool lr_w(arrayD * Y, matrixD * X, arrayD * W);	//linear regression
	bool lg_w(arrayD * Y, matrixD * X, arrayD * W);  //logistic regression
	~lr();
};

