/*************************************************************************
GRANVIL software:  January, 2010

Contributors:
    * Andrew P Morris amorris@well.ox.ac.uk
    * Reedik Magi reedik@well.ox.ac.uk

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*************************************************************************/

#include "sample.h"
#include <string>
#include <vector>
sample::sample(std::string name)
{
	_name = name;
	_affectionStatus = -9999;
	_phenotype = -9999;
    _sex = 0;
}

sample::~sample(void)
{
}

void 
sample::setSex(int sex)
{
    _sex = sex;
}
int 
sample::getSex()
{
    return _sex;
}


void 
sample::setStatus(int status)
{
	_affectionStatus = status;
}

void
sample::setPhenotype(double phenotype)
{
	_phenotype = phenotype;
}

void 
sample::addCovariate(double covariate)
{
	_covariates.push_back(covariate);
}

int 
sample::getStatus()
{
	return _affectionStatus;
}

double 
sample::getCovariate(unsigned int i)
{
	if (_covariates.size()<=i) return -9999;
	return _covariates[i];
}
double 
sample::getPhenotype()
{
	return _phenotype;
}

unsigned long 
sample::getCovariateCount()
{
	return _covariates.size();
}
std::string
sample::getName()
{
	return _name;
}

bool
sample::isOK()
{
	if (_affectionStatus == -9999 && _phenotype == -9999) return false;
    if (_sex == -9999) return false;
	for (unsigned int i = 0; i < _covariates.size(); i++)
	{
		if (_covariates[i] == -9999) return false;
	}
	return true;
}

