/*************************************************************************
GRANVIL software:  January, 2010

Contributors:
    * Andrew P Morris amorris@well.ox.ac.uk
    * Reedik Magi reedik@well.ox.ac.uk

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*************************************************************************/

#ifndef __SAMPLE_H__
#define __SAMPLE_H__

#include <string>
#include <vector>
class sample
{
public:
	sample(std::string name);
	~sample(void);
	void setStatus(int status);
    void setSex(int sex);
	void setPhenotype(double phenotype);
	void addCovariate(double covariate);
	int getStatus();
    int getSex();
	double getCovariate(unsigned int i);
	double getPhenotype();
	unsigned long getCovariateCount();
	bool isOK();
	std::string getName();
private:
	std::string _name;
	int _affectionStatus;
	double _phenotype;
    int _sex;
	std::vector <double> _covariates;
};
#endif

